/*
 * Copyright (C) 2020  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef UNWRAP_GET_ZONE_LIST_HH_0588596C5BA4CB3F313090A8DC80BAAB//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define UNWRAP_GET_ZONE_LIST_HH_0588596C5BA4CB3F313090A8DC80BAAB

#include "client/src/cfg.hh"

#include <string>
#include <vector>

namespace Fred {
namespace Zone {
namespace Client {

class GetZoneListVisitor;

void unwrap_get_zone_list(const Cfg::Options::ZoneService& zone_service_options, GetZoneListVisitor& visitor);

class GetZoneListVisitor
{
private:
    virtual void operator()(std::vector<std::string> zones) = 0;
    friend void unwrap_get_zone_list(const Cfg::Options::ZoneService&, GetZoneListVisitor&);
};
}//namespace Fred::Zone::Client
}//namespace Fred::Zone
}//namespace Fred

#endif//UNWRAP_GET_ZONE_LIST_HH_0588596C5BA4CB3F313090A8DC80BAAB
