cmake_minimum_required(VERSION 3.5)

set(API_DIAGNOSTICS_VERSION "1.0.2")
message(STATUS "API_DIAGNOSTICS_VERSION: ${API_DIAGNOSTICS_VERSION}")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/include.cmake")
set(PROTOS_DIR ${CMAKE_CURRENT_LIST_DIR})
set(PROTOBUF_IMPORT_DIRS ${PROTOS_DIR})
set(FRED_DIAGNOSTICS_GENERATE_INTO ${CMAKE_CURRENT_BINARY_DIR})

set(FRED_DIAGNOSTICS_PROTO_FILES
    ${PROTOS_DIR}/fred_api/diagnostics/service_diagnostics_grpc.proto)
set(FRED_DIAGNOSTICS_GRPC_FILES
    ${PROTOS_DIR}/fred_api/diagnostics/service_diagnostics_grpc.proto)

find_package(ProtobufCpp REQUIRED)
find_package(GrpcCpp REQUIRED)

protobuf_generate_cpp(FRED_DIAGNOSTICS_PROTO_SRCS FRED_DIAGNOSTICS_PROTO_HDRS ${FRED_DIAGNOSTICS_GENERATE_INTO} ${FRED_DIAGNOSTICS_PROTO_FILES})
grpc_generate_cpp(FRED_DIAGNOSTICS_GRPC_SRCS FRED_DIAGNOSTICS_GRPC_HDRS ${FRED_DIAGNOSTICS_GENERATE_INTO} ${FRED_DIAGNOSTICS_GRPC_FILES})
