/*
 * Copyright (C) 2020  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef COMMON_TYPES_WRAPPERS_HH_30C3524FD4D4AD4BB660C65913B5755E//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define COMMON_TYPES_WRAPPERS_HH_30C3524FD4D4AD4BB660C65913B5755E

#include "src/impl/lib/zone_data.hh"
#include "src/impl/lib/zone_list.hh"

#include "fred_api/zone/service_zone_grpc.pb.h"

namespace Fred {
namespace Zone {
namespace Iface {
namespace Tools {

void wrap(const Impl::Lib::ZoneData::SoaRecord::RData& src, Api::SoaRecord::Rdata* dst);
void wrap(const Impl::Lib::ZoneData::Common& src, Api::ZoneDataReply::Data* dst);
void wrap(const Impl::Lib::AbsoluteFqdn& src, Api::AbsoluteDomainName* dst);
void wrap(const Impl::Lib::ZoneData::Domain& src, ::google::protobuf::RepeatedPtrField<Api::DomainRecord>* dst);
void wrap(const boost::asio::ip::address_v4& src, Api::DomainRecord::ARdata* dst);
void wrap(const boost::asio::ip::address_v6& src, Api::DomainRecord::AaaaRdata* dst);
void wrap(const boost::asio::ip::address_v4& src, Api::IPv4Address* dst);
void wrap(const boost::asio::ip::address_v6& src, Api::IPv6Address* dst);
void wrap(const Impl::Lib::ZoneData::DsRData& src, Api::DomainRecord::DsRdata* dst);
void wrap(const Impl::Lib::ZoneData::DsRData::Digest& src, Api::DomainRecord::DsRdata::Digest* dst);
void wrap(const Impl::Lib::ZoneName& src, Api::ZoneName* dst);
void wrap(const Impl::Lib::ZoneList& src, Api::ZoneListReply* dst);

}//namespace Fred::Zone::Iface::Tools
}//namespace Fred::Zone::Iface
}//namespace Fred::Zone
}//namespace Fred

#endif//COMMON_TYPES_WRAPPERS_HH_30C3524FD4D4AD4BB660C65913B5755E
