/*
 * Copyright (C) 2020-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef TOOLS_HH_956D2A8606F311A2CA5EEA147FF90C05//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define TOOLS_HH_956D2A8606F311A2CA5EEA147FF90C05

#include "src/impl/lib/exception.hh"

#include "libpg/pg_exception.hh"

#include <grpc++/grpc++.h>

namespace Fred {
namespace Zone {
namespace Iface {
namespace Tools {

grpc::Status on_not_found(const Impl::Lib::NotFound& e);

grpc::Status on_runtime_error(const Impl::Lib::RuntimeError& e);

grpc::Status on_database_error(const LibPg::ConnectFailure& e);
grpc::Status on_database_error(const LibPg::ExecFailure& e);
grpc::Status on_database_error(const LibPg::PgException& e);

grpc::Status on_std_exception(const std::exception& e);

grpc::Status on_unknown_exception();

}//namespace Fred::Zone::Iface::Tools
}//namespace Fred::Zone::Iface
}//namespace Fred::Zone
}//namespace Fred

#endif//TOOLS_HH_956D2A8606F311A2CA5EEA147FF90C05
