/*
 * Copyright (C) 2020  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef ZONE_SERVICE_HH_15FC0FFAF08D2EF2445FEB8C2E7A9D7E//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define ZONE_SERVICE_HH_15FC0FFAF08D2EF2445FEB8C2E7A9D7E

#include "fred_api/zone/service_zone_grpc.grpc.pb.h"

namespace Fred {
namespace Zone {
namespace Iface {

class ZoneService final : public Api::Zone::Service
{
private:
    grpc::Status get_zone_list(
            grpc::ServerContext*,
            const ::google::protobuf::Empty*,
            ::Fred::Zone::Api::ZoneListReply* reply) override;
    grpc::Status get_zone_data(
            grpc::ServerContext*,
            const ::Fred::Zone::Api::ZoneDataRequest* api_request,
            grpc::ServerWriter<Api::ZoneDataReply>* writer) override;
};

}//namespace Fred::Zone::Iface
}//namespace Fred::Zone
}//namespace Fred

#endif//ZONE_SERVICE_HH_15FC0FFAF08D2EF2445FEB8C2E7A9D7E
