/*
 * Copyright (C) 2020-2021  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef ABSOLUTE_FQDN_HH_462041C4B9E9F0D2750C002CCA44FC7D//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define ABSOLUTE_FQDN_HH_462041C4B9E9F0D2750C002CCA44FC7D

#include "src/impl/lib/strong_type.hh"

#include <string>

namespace Fred {
namespace Zone {
namespace Impl {
namespace Lib {

using Fqdn = StrongString<struct FqdnTag_>;

class AbsoluteFqdn
{
public:
    AbsoluteFqdn() = delete;
    explicit AbsoluteFqdn(Fqdn fqdn);
    Fqdn get_fqdn() const;
    bool is_subdomain_of(const AbsoluteFqdn& domain) const noexcept;
private:
    friend bool operator<(const AbsoluteFqdn& lhs, const AbsoluteFqdn& rhs) noexcept;
    Fqdn fqdn_;
};

AbsoluteFqdn make_absolute(Fqdn fqdn);

}//namespace Fred::Zone::Impl::Lib
}//namespace Fred::Zone::Impl
}//namespace Fred::Zone
}//namespace Fred

#endif//ABSOLUTE_FQDN_HH_462041C4B9E9F0D2750C002CCA44FC7D
