/*
 * Copyright (C) 2020  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef EXCEPTION_HH_9E68EE09F6885398387C642E78D4BF8B//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define EXCEPTION_HH_9E68EE09F6885398387C642E78D4BF8B

#include <functional>
#include <stdexcept>

namespace Fred {
namespace Zone {
namespace Impl {
namespace Lib {

using ExceptionWhatFunction = std::function<const char*()noexcept>;

[[noreturn]] void throw_runtime_error(ExceptionWhatFunction what_impl);
[[noreturn]] void throw_not_found(ExceptionWhatFunction what_impl);

struct RuntimeError : std::runtime_error
{
    RuntimeError();
};

struct NotFound : RuntimeError
{
};

}//namespace Fred::Zone::Impl::Lib
}//namespace Fred::Zone::Impl
}//namespace Fred::Zone
}//namespace Fred

#endif//EXCEPTION_HH_9E68EE09F6885398387C642E78D4BF8B
