/*
 * Copyright (C) 2020  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef WIRE_FORMAT_HH_B3D4A41BB2A58FC9605CDC598F49F625//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define WIRE_FORMAT_HH_B3D4A41BB2A58FC9605CDC598F49F625

#include "src/impl/lib/absolute_fqdn.hh"
#include "src/impl/lib/dnskey_record.hh"

#include <cstdint>
#include <vector>

namespace Fred {
namespace Zone {
namespace Impl {
namespace Lib {

class WireFormat
{
public:
    WireFormat();
    WireFormat& append(const AbsoluteFqdn& absolute_fqdn);
    WireFormat& append(const DnsKey& dns_key);
    const std::vector<std::uint8_t>& data() const &;
    std::vector<std::uint8_t> data() &&;
private:
    std::vector<std::uint8_t> data_;
};

}//namespace Fred::Zone::Impl::Lib
}//namespace Fred::Zone::Impl
}//namespace Fred::Zone
}//namespace Fred

#endif//WIRE_FORMAT_HH_B3D4A41BB2A58FC9605CDC598F49F625
