/*
 * Copyright (C) 2020-2021  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "src/impl/zone_data.hh"

#include "src/cfg.hh"

#include "src/impl/lib/get_zone_data_context.hh"

#include "src/util/util.hh"

#include "liblog/liblog.hh"

#include <algorithm>
#include <stdexcept>

namespace Fred {
namespace Zone {
namespace Impl {

namespace {

decltype(auto) get_zone_data_options()
{
    return Lib::ZoneData::Options{Cfg::Options::get().ds_record.digest_types};
}

}//namespace Fred::Zone::Impl::{anonymous}

Lib::ZoneData get_zone_data(const ZoneName& zone)
{
    auto ctx = Lib::get_zone_data_context({Util::make_connection(),
                                           Util::make_connection(),
                                           Util::make_connection()},
                                          Lib::ZoneName{*zone});
    return Lib::ZoneData{std::move(ctx), get_zone_data_options()};
}

}//namespace Fred::Zone::Impl
}//namespace Fred::Zone
}//namespace Fred
