/*
 * Copyright (C) 2020  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef SETUP_HH_3205DD10202CAD635CFC40A9EC7710A0//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define SETUP_HH_3205DD10202CAD635CFC40A9EC7710A0

#include "libpg/pg_connection.hh"
#include "libpg/pg_ro_transaction.hh"

namespace Test {

using SessionDefault = LibPg::PgTransaction::SessionDefault;
using SerializableDeferrable = LibPg::PgTransaction::Serializable<LibPg::PgTransaction::Deferrable>;

LibPg::PgConnection make_connection();

template <typename Level = SessionDefault>
LibPg::PgRoTransaction make_transaction(LibPg::PgTransaction::IsolationLevel<Level> level = LibPg::PgTransaction::session_default);

extern template LibPg::PgRoTransaction make_transaction<>(LibPg::PgTransaction::IsolationLevel<SessionDefault>);

}//namespace Test

#endif//SETUP_HH_3205DD10202CAD635CFC40A9EC7710A0
